// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: ibc/applications/fee/v1/genesis.proto

package types

import (
	fmt "fmt"
	types "github.com/cosmos/ibc-go/v5/modules/core/04-channel/types"
	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	io "io"
	math "math"
	math_bits "math/bits"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// GenesisState defines the ICS29 fee middleware genesis state
type GenesisState struct {
	// list of identified packet fees
	IdentifiedFees []IdentifiedPacketFees `protobuf:"bytes,1,rep,name=identified_fees,json=identifiedFees,proto3" json:"identified_fees" yaml:"identified_fees"`
	// list of fee enabled channels
	FeeEnabledChannels []FeeEnabledChannel `protobuf:"bytes,2,rep,name=fee_enabled_channels,json=feeEnabledChannels,proto3" json:"fee_enabled_channels" yaml:"fee_enabled_channels"`
	// list of registered payees
	RegisteredPayees []RegisteredPayee `protobuf:"bytes,3,rep,name=registered_payees,json=registeredPayees,proto3" json:"registered_payees" yaml:"registered_payees"`
	// list of registered counterparty payees
	RegisteredCounterpartyPayees []RegisteredCounterpartyPayee `protobuf:"bytes,4,rep,name=registered_counterparty_payees,json=registeredCounterpartyPayees,proto3" json:"registered_counterparty_payees" yaml:"registered_counterparty_payees"`
	// list of forward relayer addresses
	ForwardRelayers []ForwardRelayerAddress `protobuf:"bytes,5,rep,name=forward_relayers,json=forwardRelayers,proto3" json:"forward_relayers" yaml:"forward_relayers"`
}

func (m *GenesisState) Reset()         { *m = GenesisState{} }
func (m *GenesisState) String() string { return proto.CompactTextString(m) }
func (*GenesisState) ProtoMessage()    {}
func (*GenesisState) Descriptor() ([]byte, []int) {
	return fileDescriptor_7191992e856dff95, []int{0}
}
func (m *GenesisState) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *GenesisState) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_GenesisState.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *GenesisState) XXX_Merge(src proto.Message) {
	xxx_messageInfo_GenesisState.Merge(m, src)
}
func (m *GenesisState) XXX_Size() int {
	return m.Size()
}
func (m *GenesisState) XXX_DiscardUnknown() {
	xxx_messageInfo_GenesisState.DiscardUnknown(m)
}

var xxx_messageInfo_GenesisState proto.InternalMessageInfo

func (m *GenesisState) GetIdentifiedFees() []IdentifiedPacketFees {
	if m != nil {
		return m.IdentifiedFees
	}
	return nil
}

func (m *GenesisState) GetFeeEnabledChannels() []FeeEnabledChannel {
	if m != nil {
		return m.FeeEnabledChannels
	}
	return nil
}

func (m *GenesisState) GetRegisteredPayees() []RegisteredPayee {
	if m != nil {
		return m.RegisteredPayees
	}
	return nil
}

func (m *GenesisState) GetRegisteredCounterpartyPayees() []RegisteredCounterpartyPayee {
	if m != nil {
		return m.RegisteredCounterpartyPayees
	}
	return nil
}

func (m *GenesisState) GetForwardRelayers() []ForwardRelayerAddress {
	if m != nil {
		return m.ForwardRelayers
	}
	return nil
}

// FeeEnabledChannel contains the PortID & ChannelID for a fee enabled channel
type FeeEnabledChannel struct {
	// unique port identifier
	PortId string `protobuf:"bytes,1,opt,name=port_id,json=portId,proto3" json:"port_id,omitempty" yaml:"port_id"`
	// unique channel identifier
	ChannelId string `protobuf:"bytes,2,opt,name=channel_id,json=channelId,proto3" json:"channel_id,omitempty" yaml:"channel_id"`
}

func (m *FeeEnabledChannel) Reset()         { *m = FeeEnabledChannel{} }
func (m *FeeEnabledChannel) String() string { return proto.CompactTextString(m) }
func (*FeeEnabledChannel) ProtoMessage()    {}
func (*FeeEnabledChannel) Descriptor() ([]byte, []int) {
	return fileDescriptor_7191992e856dff95, []int{1}
}
func (m *FeeEnabledChannel) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *FeeEnabledChannel) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_FeeEnabledChannel.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *FeeEnabledChannel) XXX_Merge(src proto.Message) {
	xxx_messageInfo_FeeEnabledChannel.Merge(m, src)
}
func (m *FeeEnabledChannel) XXX_Size() int {
	return m.Size()
}
func (m *FeeEnabledChannel) XXX_DiscardUnknown() {
	xxx_messageInfo_FeeEnabledChannel.DiscardUnknown(m)
}

var xxx_messageInfo_FeeEnabledChannel proto.InternalMessageInfo

func (m *FeeEnabledChannel) GetPortId() string {
	if m != nil {
		return m.PortId
	}
	return ""
}

func (m *FeeEnabledChannel) GetChannelId() string {
	if m != nil {
		return m.ChannelId
	}
	return ""
}

// RegisteredPayee contains the relayer address and payee address for a specific channel
type RegisteredPayee struct {
	// unique channel identifier
	ChannelId string `protobuf:"bytes,1,opt,name=channel_id,json=channelId,proto3" json:"channel_id,omitempty" yaml:"channel_id"`
	// the relayer address
	Relayer string `protobuf:"bytes,2,opt,name=relayer,proto3" json:"relayer,omitempty"`
	// the payee address
	Payee string `protobuf:"bytes,3,opt,name=payee,proto3" json:"payee,omitempty"`
}

func (m *RegisteredPayee) Reset()         { *m = RegisteredPayee{} }
func (m *RegisteredPayee) String() string { return proto.CompactTextString(m) }
func (*RegisteredPayee) ProtoMessage()    {}
func (*RegisteredPayee) Descriptor() ([]byte, []int) {
	return fileDescriptor_7191992e856dff95, []int{2}
}
func (m *RegisteredPayee) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *RegisteredPayee) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_RegisteredPayee.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *RegisteredPayee) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RegisteredPayee.Merge(m, src)
}
func (m *RegisteredPayee) XXX_Size() int {
	return m.Size()
}
func (m *RegisteredPayee) XXX_DiscardUnknown() {
	xxx_messageInfo_RegisteredPayee.DiscardUnknown(m)
}

var xxx_messageInfo_RegisteredPayee proto.InternalMessageInfo

func (m *RegisteredPayee) GetChannelId() string {
	if m != nil {
		return m.ChannelId
	}
	return ""
}

func (m *RegisteredPayee) GetRelayer() string {
	if m != nil {
		return m.Relayer
	}
	return ""
}

func (m *RegisteredPayee) GetPayee() string {
	if m != nil {
		return m.Payee
	}
	return ""
}

// RegisteredCounterpartyPayee contains the relayer address and counterparty payee address for a specific channel (used
// for recv fee distribution)
type RegisteredCounterpartyPayee struct {
	// unique channel identifier
	ChannelId string `protobuf:"bytes,1,opt,name=channel_id,json=channelId,proto3" json:"channel_id,omitempty" yaml:"channel_id"`
	// the relayer address
	Relayer string `protobuf:"bytes,2,opt,name=relayer,proto3" json:"relayer,omitempty"`
	// the counterparty payee address
	CounterpartyPayee string `protobuf:"bytes,3,opt,name=counterparty_payee,json=counterpartyPayee,proto3" json:"counterparty_payee,omitempty" yaml:"counterparty_payee"`
}

func (m *RegisteredCounterpartyPayee) Reset()         { *m = RegisteredCounterpartyPayee{} }
func (m *RegisteredCounterpartyPayee) String() string { return proto.CompactTextString(m) }
func (*RegisteredCounterpartyPayee) ProtoMessage()    {}
func (*RegisteredCounterpartyPayee) Descriptor() ([]byte, []int) {
	return fileDescriptor_7191992e856dff95, []int{3}
}
func (m *RegisteredCounterpartyPayee) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *RegisteredCounterpartyPayee) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_RegisteredCounterpartyPayee.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *RegisteredCounterpartyPayee) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RegisteredCounterpartyPayee.Merge(m, src)
}
func (m *RegisteredCounterpartyPayee) XXX_Size() int {
	return m.Size()
}
func (m *RegisteredCounterpartyPayee) XXX_DiscardUnknown() {
	xxx_messageInfo_RegisteredCounterpartyPayee.DiscardUnknown(m)
}

var xxx_messageInfo_RegisteredCounterpartyPayee proto.InternalMessageInfo

func (m *RegisteredCounterpartyPayee) GetChannelId() string {
	if m != nil {
		return m.ChannelId
	}
	return ""
}

func (m *RegisteredCounterpartyPayee) GetRelayer() string {
	if m != nil {
		return m.Relayer
	}
	return ""
}

func (m *RegisteredCounterpartyPayee) GetCounterpartyPayee() string {
	if m != nil {
		return m.CounterpartyPayee
	}
	return ""
}

// ForwardRelayerAddress contains the forward relayer address and PacketId used for async acknowledgements
type ForwardRelayerAddress struct {
	// the forward relayer address
	Address string `protobuf:"bytes,1,opt,name=address,proto3" json:"address,omitempty"`
	// unique packet identifer comprised of the channel ID, port ID and sequence
	PacketId types.PacketId `protobuf:"bytes,2,opt,name=packet_id,json=packetId,proto3" json:"packet_id" yaml:"packet_id"`
}

func (m *ForwardRelayerAddress) Reset()         { *m = ForwardRelayerAddress{} }
func (m *ForwardRelayerAddress) String() string { return proto.CompactTextString(m) }
func (*ForwardRelayerAddress) ProtoMessage()    {}
func (*ForwardRelayerAddress) Descriptor() ([]byte, []int) {
	return fileDescriptor_7191992e856dff95, []int{4}
}
func (m *ForwardRelayerAddress) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ForwardRelayerAddress) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ForwardRelayerAddress.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ForwardRelayerAddress) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ForwardRelayerAddress.Merge(m, src)
}
func (m *ForwardRelayerAddress) XXX_Size() int {
	return m.Size()
}
func (m *ForwardRelayerAddress) XXX_DiscardUnknown() {
	xxx_messageInfo_ForwardRelayerAddress.DiscardUnknown(m)
}

var xxx_messageInfo_ForwardRelayerAddress proto.InternalMessageInfo

func (m *ForwardRelayerAddress) GetAddress() string {
	if m != nil {
		return m.Address
	}
	return ""
}

func (m *ForwardRelayerAddress) GetPacketId() types.PacketId {
	if m != nil {
		return m.PacketId
	}
	return types.PacketId{}
}

func init() {
	proto.RegisterType((*GenesisState)(nil), "ibc.applications.fee.v1.GenesisState")
	proto.RegisterType((*FeeEnabledChannel)(nil), "ibc.applications.fee.v1.FeeEnabledChannel")
	proto.RegisterType((*RegisteredPayee)(nil), "ibc.applications.fee.v1.RegisteredPayee")
	proto.RegisterType((*RegisteredCounterpartyPayee)(nil), "ibc.applications.fee.v1.RegisteredCounterpartyPayee")
	proto.RegisterType((*ForwardRelayerAddress)(nil), "ibc.applications.fee.v1.ForwardRelayerAddress")
}

func init() {
	proto.RegisterFile("ibc/applications/fee/v1/genesis.proto", fileDescriptor_7191992e856dff95)
}

var fileDescriptor_7191992e856dff95 = []byte{
	// 647 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x54, 0xcd, 0x4e, 0xd4, 0x40,
	0x1c, 0xdf, 0x82, 0x80, 0x0c, 0x06, 0xd8, 0x09, 0x48, 0x05, 0xe9, 0xe2, 0x18, 0x12, 0xa2, 0xd9,
	0x36, 0x20, 0x1c, 0xf4, 0x66, 0x89, 0x98, 0x4d, 0x4c, 0x24, 0xa3, 0x27, 0x2f, 0x9b, 0x6e, 0xfb,
	0xef, 0xd2, 0xb8, 0xdb, 0x69, 0x66, 0x86, 0x25, 0xeb, 0xcd, 0x93, 0x57, 0x5f, 0xc3, 0xf8, 0x08,
	0xbe, 0x00, 0x47, 0x8e, 0x9e, 0x36, 0x06, 0xde, 0x60, 0x9f, 0xc0, 0x4c, 0x67, 0x0a, 0xcb, 0x7e,
	0x18, 0x0e, 0xde, 0x66, 0x3a, 0xbf, 0xaf, 0xe9, 0x6f, 0xf2, 0x47, 0xdb, 0x49, 0x23, 0xf4, 0x82,
	0x2c, 0x6b, 0x25, 0x61, 0x20, 0x13, 0x96, 0x0a, 0x2f, 0x06, 0xf0, 0x3a, 0xbb, 0x5e, 0x13, 0x52,
	0x10, 0x89, 0x70, 0x33, 0xce, 0x24, 0xc3, 0x6b, 0x49, 0x23, 0x74, 0x07, 0x61, 0x6e, 0x0c, 0xe0,
	0x76, 0x76, 0xd7, 0x57, 0x9a, 0xac, 0xc9, 0x72, 0x8c, 0xa7, 0x56, 0x1a, 0xbe, 0xfe, 0x64, 0x92,
	0xaa, 0x62, 0x0d, 0x40, 0x42, 0xc6, 0xc1, 0x0b, 0x4f, 0x82, 0x34, 0x85, 0x96, 0x3a, 0x36, 0x4b,
	0x0d, 0x21, 0x3f, 0x67, 0xd0, 0x83, 0xb7, 0x3a, 0xc6, 0x07, 0x19, 0x48, 0xc0, 0x1d, 0xb4, 0x94,
	0x44, 0x90, 0xca, 0x24, 0x4e, 0x20, 0xaa, 0xc7, 0x00, 0xc2, 0xb6, 0xb6, 0xa6, 0x77, 0x16, 0xf6,
	0xaa, 0xee, 0x84, 0x7c, 0x6e, 0xed, 0x1a, 0x7f, 0x1c, 0x84, 0x9f, 0x41, 0x1e, 0x01, 0x08, 0xdf,
	0x39, 0xef, 0x55, 0x4a, 0xfd, 0x5e, 0xe5, 0x61, 0x37, 0x68, 0xb7, 0x5e, 0x91, 0x21, 0x4d, 0x42,
	0x17, 0x6f, 0xbe, 0x28, 0x3c, 0xfe, 0x6a, 0xa1, 0x95, 0x18, 0xa0, 0x0e, 0x69, 0xd0, 0x68, 0x41,
	0x54, 0x37, 0x31, 0x85, 0x3d, 0x95, 0xbb, 0x3f, 0x9b, 0xe8, 0x7e, 0x04, 0xf0, 0x46, 0x73, 0x0e,
	0x35, 0xc5, 0x7f, 0x6a, 0xac, 0x37, 0xb4, 0xf5, 0x38, 0x55, 0x42, 0x71, 0x3c, 0xcc, 0x13, 0xf8,
	0x0c, 0x95, 0x39, 0x34, 0x13, 0x21, 0x81, 0x43, 0x54, 0xcf, 0x82, 0xae, 0xba, 0xfd, 0x74, 0xee,
	0xbf, 0x33, 0xd1, 0x9f, 0x5e, 0x33, 0x8e, 0x15, 0xc1, 0xdf, 0x32, 0xee, 0xb6, 0x76, 0x1f, 0x11,
	0x24, 0x74, 0x99, 0xdf, 0xa6, 0x08, 0xfc, 0xc3, 0x42, 0xce, 0x00, 0x30, 0x64, 0xa7, 0xa9, 0x04,
	0x9e, 0x05, 0x5c, 0x76, 0x8b, 0x18, 0xf7, 0xf2, 0x18, 0xfb, 0x77, 0x88, 0x71, 0x38, 0xc0, 0xd6,
	0x91, 0xaa, 0x26, 0xd2, 0xf6, 0x48, 0xa4, 0x31, 0x4e, 0x84, 0x3e, 0xe6, 0x93, 0xb5, 0x04, 0xfe,
	0x82, 0x96, 0x63, 0xc6, 0xcf, 0x02, 0x1e, 0xd5, 0x39, 0xb4, 0x82, 0x2e, 0x70, 0x61, 0xcf, 0xe4,
	0xe1, 0xdc, 0xc9, 0x1d, 0x69, 0x02, 0xd5, 0xf8, 0xd7, 0x51, 0xc4, 0x41, 0x08, 0xbf, 0x62, 0x62,
	0xad, 0x99, 0x9e, 0x86, 0x54, 0x09, 0x5d, 0x8a, 0x6f, 0xf1, 0x04, 0xe9, 0xa0, 0xf2, 0x48, 0xdd,
	0xf8, 0x39, 0x9a, 0xcb, 0x18, 0x97, 0xf5, 0x24, 0xb2, 0xad, 0x2d, 0x6b, 0x67, 0xde, 0xc7, 0xfd,
	0x5e, 0x65, 0x51, 0x6b, 0x9a, 0x03, 0x42, 0x67, 0xd5, 0xaa, 0x16, 0xe1, 0x7d, 0x84, 0xcc, 0x1b,
	0x50, 0xf8, 0xa9, 0x1c, 0xbf, 0xda, 0xef, 0x55, 0xca, 0x1a, 0x7f, 0x73, 0x46, 0xe8, 0xbc, 0xd9,
	0xd4, 0x22, 0x72, 0x86, 0x96, 0x86, 0x6a, 0x1e, 0x12, 0xb2, 0xee, 0x26, 0x84, 0x6d, 0x34, 0x67,
	0xae, 0xa7, 0xbd, 0x69, 0xb1, 0xc5, 0x2b, 0x68, 0x26, 0xff, 0xff, 0xf6, 0x74, 0xfe, 0x5d, 0x6f,
	0xc8, 0x2f, 0x0b, 0x6d, 0xfc, 0xa3, 0xd9, 0xff, 0x9e, 0xe2, 0x1d, 0xc2, 0xa3, 0x4f, 0x42, 0x47,
	0xf2, 0x37, 0xfb, 0xbd, 0xca, 0x23, 0xa3, 0x3b, 0x82, 0x21, 0xb4, 0x1c, 0x0e, 0xa7, 0x23, 0xdf,
	0x2c, 0xb4, 0x3a, 0xb6, 0x7a, 0x95, 0x20, 0xd0, 0x4b, 0x1d, 0x9a, 0x16, 0x5b, 0xfc, 0x11, 0xcd,
	0x67, 0xf9, 0x14, 0x29, 0xfa, 0x59, 0xd8, 0xdb, 0xcc, 0xdf, 0x95, 0x9a, 0x63, 0x6e, 0x31, 0xbc,
	0x3a, 0xbb, 0xae, 0x9e, 0x35, 0xb5, 0xc8, 0xb7, 0xcd, 0x33, 0x5a, 0x36, 0x95, 0x17, 0x6c, 0x42,
	0xef, 0x67, 0x05, 0xe6, 0xfd, 0xf9, 0xa5, 0x63, 0x5d, 0x5c, 0x3a, 0xd6, 0x9f, 0x4b, 0xc7, 0xfa,
	0x7e, 0xe5, 0x94, 0x2e, 0xae, 0x9c, 0xd2, 0xef, 0x2b, 0xa7, 0xf4, 0xe9, 0xa0, 0x99, 0xc8, 0x93,
	0xd3, 0x86, 0x1b, 0xb2, 0xb6, 0x17, 0x32, 0xd1, 0x66, 0xc2, 0x4b, 0x1a, 0x61, 0xb5, 0xc9, 0xbc,
	0xce, 0x81, 0xd7, 0x66, 0xd1, 0x69, 0x0b, 0x84, 0x1a, 0xb3, 0xc2, 0xdb, 0x7b, 0x59, 0x55, 0x13,
	0x56, 0x76, 0x33, 0x10, 0x8d, 0xd9, 0x7c, 0x7c, 0xbe, 0xf8, 0x1b, 0x00, 0x00, 0xff, 0xff, 0xf4,
	0x0f, 0x0d, 0xd4, 0xdc, 0x05, 0x00, 0x00,
}

func (m *GenesisState) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *GenesisState) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *GenesisState) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.ForwardRelayers) > 0 {
		for iNdEx := len(m.ForwardRelayers) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.ForwardRelayers[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintGenesis(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x2a
		}
	}
	if len(m.RegisteredCounterpartyPayees) > 0 {
		for iNdEx := len(m.RegisteredCounterpartyPayees) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.RegisteredCounterpartyPayees[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintGenesis(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x22
		}
	}
	if len(m.RegisteredPayees) > 0 {
		for iNdEx := len(m.RegisteredPayees) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.RegisteredPayees[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintGenesis(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x1a
		}
	}
	if len(m.FeeEnabledChannels) > 0 {
		for iNdEx := len(m.FeeEnabledChannels) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.FeeEnabledChannels[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintGenesis(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x12
		}
	}
	if len(m.IdentifiedFees) > 0 {
		for iNdEx := len(m.IdentifiedFees) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.IdentifiedFees[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintGenesis(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0xa
		}
	}
	return len(dAtA) - i, nil
}

func (m *FeeEnabledChannel) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *FeeEnabledChannel) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *FeeEnabledChannel) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.ChannelId) > 0 {
		i -= len(m.ChannelId)
		copy(dAtA[i:], m.ChannelId)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.ChannelId)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.PortId) > 0 {
		i -= len(m.PortId)
		copy(dAtA[i:], m.PortId)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.PortId)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *RegisteredPayee) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *RegisteredPayee) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *RegisteredPayee) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Payee) > 0 {
		i -= len(m.Payee)
		copy(dAtA[i:], m.Payee)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.Payee)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Relayer) > 0 {
		i -= len(m.Relayer)
		copy(dAtA[i:], m.Relayer)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.Relayer)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.ChannelId) > 0 {
		i -= len(m.ChannelId)
		copy(dAtA[i:], m.ChannelId)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.ChannelId)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *RegisteredCounterpartyPayee) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *RegisteredCounterpartyPayee) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *RegisteredCounterpartyPayee) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.CounterpartyPayee) > 0 {
		i -= len(m.CounterpartyPayee)
		copy(dAtA[i:], m.CounterpartyPayee)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.CounterpartyPayee)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Relayer) > 0 {
		i -= len(m.Relayer)
		copy(dAtA[i:], m.Relayer)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.Relayer)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.ChannelId) > 0 {
		i -= len(m.ChannelId)
		copy(dAtA[i:], m.ChannelId)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.ChannelId)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *ForwardRelayerAddress) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ForwardRelayerAddress) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ForwardRelayerAddress) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size, err := m.PacketId.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintGenesis(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x12
	if len(m.Address) > 0 {
		i -= len(m.Address)
		copy(dAtA[i:], m.Address)
		i = encodeVarintGenesis(dAtA, i, uint64(len(m.Address)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func encodeVarintGenesis(dAtA []byte, offset int, v uint64) int {
	offset -= sovGenesis(v)
	base := offset
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return base
}
func (m *GenesisState) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.IdentifiedFees) > 0 {
		for _, e := range m.IdentifiedFees {
			l = e.Size()
			n += 1 + l + sovGenesis(uint64(l))
		}
	}
	if len(m.FeeEnabledChannels) > 0 {
		for _, e := range m.FeeEnabledChannels {
			l = e.Size()
			n += 1 + l + sovGenesis(uint64(l))
		}
	}
	if len(m.RegisteredPayees) > 0 {
		for _, e := range m.RegisteredPayees {
			l = e.Size()
			n += 1 + l + sovGenesis(uint64(l))
		}
	}
	if len(m.RegisteredCounterpartyPayees) > 0 {
		for _, e := range m.RegisteredCounterpartyPayees {
			l = e.Size()
			n += 1 + l + sovGenesis(uint64(l))
		}
	}
	if len(m.ForwardRelayers) > 0 {
		for _, e := range m.ForwardRelayers {
			l = e.Size()
			n += 1 + l + sovGenesis(uint64(l))
		}
	}
	return n
}

func (m *FeeEnabledChannel) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.PortId)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	l = len(m.ChannelId)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	return n
}

func (m *RegisteredPayee) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.ChannelId)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	l = len(m.Relayer)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	l = len(m.Payee)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	return n
}

func (m *RegisteredCounterpartyPayee) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.ChannelId)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	l = len(m.Relayer)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	l = len(m.CounterpartyPayee)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	return n
}

func (m *ForwardRelayerAddress) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Address)
	if l > 0 {
		n += 1 + l + sovGenesis(uint64(l))
	}
	l = m.PacketId.Size()
	n += 1 + l + sovGenesis(uint64(l))
	return n
}

func sovGenesis(x uint64) (n int) {
	return (math_bits.Len64(x|1) + 6) / 7
}
func sozGenesis(x uint64) (n int) {
	return sovGenesis(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (m *GenesisState) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowGenesis
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: GenesisState: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: GenesisState: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field IdentifiedFees", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.IdentifiedFees = append(m.IdentifiedFees, IdentifiedPacketFees{})
			if err := m.IdentifiedFees[len(m.IdentifiedFees)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field FeeEnabledChannels", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.FeeEnabledChannels = append(m.FeeEnabledChannels, FeeEnabledChannel{})
			if err := m.FeeEnabledChannels[len(m.FeeEnabledChannels)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field RegisteredPayees", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.RegisteredPayees = append(m.RegisteredPayees, RegisteredPayee{})
			if err := m.RegisteredPayees[len(m.RegisteredPayees)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field RegisteredCounterpartyPayees", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.RegisteredCounterpartyPayees = append(m.RegisteredCounterpartyPayees, RegisteredCounterpartyPayee{})
			if err := m.RegisteredCounterpartyPayees[len(m.RegisteredCounterpartyPayees)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ForwardRelayers", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ForwardRelayers = append(m.ForwardRelayers, ForwardRelayerAddress{})
			if err := m.ForwardRelayers[len(m.ForwardRelayers)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipGenesis(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthGenesis
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *FeeEnabledChannel) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowGenesis
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: FeeEnabledChannel: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: FeeEnabledChannel: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field PortId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.PortId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ChannelId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ChannelId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipGenesis(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthGenesis
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *RegisteredPayee) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowGenesis
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: RegisteredPayee: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: RegisteredPayee: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ChannelId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ChannelId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Relayer", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Relayer = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Payee", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Payee = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipGenesis(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthGenesis
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *RegisteredCounterpartyPayee) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowGenesis
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: RegisteredCounterpartyPayee: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: RegisteredCounterpartyPayee: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ChannelId", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ChannelId = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Relayer", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Relayer = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field CounterpartyPayee", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.CounterpartyPayee = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipGenesis(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthGenesis
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ForwardRelayerAddress) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowGenesis
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ForwardRelayerAddress: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ForwardRelayerAddress: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Address", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Address = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field PacketId", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthGenesis
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthGenesis
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.PacketId.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipGenesis(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthGenesis
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipGenesis(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	depth := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowGenesis
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
		case 1:
			iNdEx += 8
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowGenesis
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if length < 0 {
				return 0, ErrInvalidLengthGenesis
			}
			iNdEx += length
		case 3:
			depth++
		case 4:
			if depth == 0 {
				return 0, ErrUnexpectedEndOfGroupGenesis
			}
			depth--
		case 5:
			iNdEx += 4
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
		if iNdEx < 0 {
			return 0, ErrInvalidLengthGenesis
		}
		if depth == 0 {
			return iNdEx, nil
		}
	}
	return 0, io.ErrUnexpectedEOF
}

var (
	ErrInvalidLengthGenesis        = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowGenesis          = fmt.Errorf("proto: integer overflow")
	ErrUnexpectedEndOfGroupGenesis = fmt.Errorf("proto: unexpected end of group")
)
